KGeom::KGeom()
{
}


KGeom::~KGeom()
{
}


inline void KGeom::GenDL()
{
	dl = glGenLists(KIEK);
}


void KGeom::Init()
{
	GenDL();
	PlokstDL();
	PlokstWireDL();
	KubasDL();
	KubasSpDL();
	KubasWireDL();
	ZiedasDL();
	ZiedasWireDL();
}


void KGeom::Naikinti()
{
	glDeleteLists(dl, KIEK);
}


//-- 2D ------------------------------------------------------------------------

inline void KGeom::Plokst(GLfloat plotis = 1.0)
{
	glScalef(plotis, plotis, 1.0);
	glCallList(dl + PLOKST);
	glScalef(1.0 / plotis, 1.0 / plotis, 1.0);
}


inline void KGeom::Plokst(GLfloat plotis, GLfloat aukstis)
{
	glScalef(plotis, aukstis, 1.0);
	glCallList(dl + PLOKST);
	glScalef(1.0 / plotis, 1.0 / aukstis, 1.0);
}


void KGeom::PlokstDL()
{
	GLfloat plotis = 0.5;
	glNewList(dl + PLOKST, GL_COMPILE);
	glBegin(GL_QUADS);
		glNormal3f(0.0, 0.0, 1.0);
		glTexCoord2f(0.0, 0.0);	glVertex3f(-plotis, -plotis, 0.0);
		glTexCoord2f(1.0, 0.0);	glVertex3f(plotis, -plotis, 0.0);
		glTexCoord2f(1.0, 1.0);	glVertex3f(plotis, plotis, 0.0);
		glTexCoord2f(0.0, 1.0);	glVertex3f(-plotis, plotis, 0.0);
	glEnd();
	glEndList();
}


inline void KGeom::PlokstWire(GLfloat plotis = 1.0)
{
	glScalef(plotis, plotis, 1.0);
	glCallList(dl + PLOKST_WIRE);
	glScalef(1.0 / plotis, 1.0 / plotis, 1.0);
}


inline void KGeom::PlokstWire(GLfloat plotis, GLfloat aukstis)
{
	glScalef(plotis, aukstis, 1.0);
	glCallList(dl + PLOKST_WIRE);
	glScalef(1.0 / plotis, 1.0 / aukstis, 1.0);
}


void KGeom::PlokstWireDL()
{
	float plotis = 0.5;
	glBegin(GL_LINE_LOOP);
		glVertex3f(-plotis, -plotis, 0.0);
		glVertex3f(plotis, -plotis, 0.0);
		glVertex3f(plotis, plotis, 0.0);
		glVertex3f(-plotis, plotis, 0.0);
	glEnd();
}


void KGeom::Apskritimas(GLfloat dydis, int kokybe)
{
	float kamp;
	glBegin(GL_LINE_LOOP);
	for(int i = 0; i < kokybe; i++){
		kamp = (float)i / (float)kokybe * M_PI * 2.0;
		glVertex3f(dydis * cos(kamp), dydis * sin(kamp), 0.0);
	}
	glEnd();
}


void KGeom::Skritulys(GLfloat dydis, int kokybe)
{
	float kamp;
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, 0.0, 1.0);
	glVertex3f(0.0, 0.0, 0.0);
	for(int i = 0; i <= kokybe; i++){
		kamp = (float)i / (float)kokybe * M_PI * 2.0;
		glVertex3f(dydis * cos(kamp), dydis * sin(kamp), 0.0);
	}
	glEnd();
}


void KGeom::Ziedas2D(GLfloat dydis1, GLfloat dydis2, int kokybe)
{
	float kamp;
	glBegin(GL_TRIANGLE_STRIP);
	glNormal3f(0.0, 0.0, 1.0);
	for(int i = 0; i <= kokybe; i++){
		kamp = (float)i / (float)kokybe * M_PI * 2.0;
		glVertex3f(dydis1 * cos(kamp), dydis1 * sin(kamp), 0.0);
		glVertex3f(dydis2 * cos(kamp), dydis2 * sin(kamp), 0.0);
	}
	glEnd();
}


//-- 3D ------------------------------------------------------------------------

void KGeom::Koord(GLfloat dydis = 10.0, int tarpu = 10)
{
	GLfloat tarpas = dydis / (GLfloat)tarpu;

	glBegin(GL_LINES);
		glColor3f(1.0, 0.0, 0.0);
		glVertex3f(-dydis, 0.0, 0.0);
		glVertex3f(dydis, 0.0, 0.0);

		glColor3f(0.0, 1.0, 0.0);
		glVertex3f(0.0, -dydis, 0.0);
		glVertex3f(0.0, dydis, 0.0);

		glColor3f(0.0, 0.0, 1.0);
		glVertex3f(0.0, 0.0, -dydis);
		glVertex3f(0.0, 0.0, dydis);

		for(GLfloat n = -dydis; n < dydis; n += tarpas){
			glColor3f(1.0, 0.0, 0.0);

			glVertex3f(n, -tarpas / 5.0, 0.0);
			glVertex3f(n, tarpas / 5.0, 0.0);

			glVertex3f(n, 0.0, -tarpas / 5.0);
			glVertex3f(n, 0.0, tarpas / 5.0);


			glColor3f(0.0, 1.0, 0.0);

			glVertex3f(-tarpas / 5.0, n, 0.0);
			glVertex3f(tarpas / 5.0, n, 0.0);

			glVertex3f(0.0, n, -tarpas / 5.0);
			glVertex3f(0.0, n, tarpas / 5.0);


			glColor3f(0.0, 0.0, 1.0);

			glVertex3f(-tarpas / 5.0, 0.0, n);
			glVertex3f(tarpas / 5.0, 0.0, n);

			glVertex3f(0.0, -tarpas / 5.0, n);
			glVertex3f(0.0, tarpas / 5.0, n);
		}
	glEnd();
	glColor4f(1.0, 1.0, 1.0, 1.0);
}


inline void KGeom::Kubas(GLfloat x = 1.0)
{
	glScalef(x, x, x);
	glCallList(dl + KUBAS);
	glScalef(1.0 / x, 1.0 / x, 1.0 / x);
}


inline void KGeom::Kubas(GLfloat x, GLfloat y, GLfloat z)
{
	glScalef(x, y, z);
	glCallList(dl + KUBAS);
	glScalef(1.0 / x, 1.0 / y, 1.0 / z);
}


void KGeom::KubasDL()
{
	GLfloat plotis = 1.0;
	glNewList(dl + KUBAS, GL_COMPILE);
	//X neigiama plokstuma
	glRotatef(-90.0, 0.0, 1.0, 0.0);
	glTranslatef(0.0, 0.0, plotis / 2.0);
	Plokst(plotis);
	//X teigiama
	glRotatef(180.0, 1.0, 0.0, 0.0);
	glTranslatef(0.0, 0.0, plotis);
	Plokst(plotis);
	//Y-
	glTranslatef(0.0, 0.0, -plotis / 2.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glTranslatef(0.0, 0.0, plotis / 2.0);
	Plokst(plotis);
	//Y+
	glRotatef(180.0, 1.0, 0.0, 0.0);
	glTranslatef(0.0, 0.0, plotis);
	Plokst(plotis);
	//Z-
	glTranslatef(0.0, 0.0, -plotis / 2.0);
	glRotatef(-90.0, 0.0, 1.0, 0.0);
	glTranslatef(0.0, 0.0, plotis / 2.0);
	Plokst(plotis);
	//Z+
	glRotatef(180.0, 0.0, 1.0, 0.0);
	glTranslatef(0.0, 0.0, plotis);
	Plokst(plotis);
	//Atstatoma pradine transformacija
	glTranslatef(0.0, 0.0, -plotis / 2.0);
	glRotatef(90.0, 0.0, 0.0, 1.0);
	glEndList();
}


inline void KGeom::KubasSp(GLfloat x = 1.0)
{
	glScalef(x, x, x);
	glCallList(dl + KUBAS_SP);
	glScalef(1.0 / x, 1.0 / x, 1.0 / x);
}


inline void KGeom::KubasSp(GLfloat x, GLfloat y, GLfloat z)
{
	glScalef(x, y, z);
	glCallList(dl + KUBAS_SP);
	glScalef(1.0 / x, 1.0 / y, 1.0 / z);
}


void KGeom::KubasSpDL()
{
	GLfloat plotis = 1.0;
	glNewList(dl + KUBAS_SP, GL_COMPILE);
	//X neigiama plokstuma
	glColor3f(1.0, 0.0, 0.0);
	glRotatef(-90.0, 0.0, 1.0, 0.0);
	glTranslatef(0.0, 0.0, plotis / 2.0);
	Plokst(plotis);
	//X teigiama
	glRotatef(180.0, 1.0, 0.0, 0.0);
	glTranslatef(0.0, 0.0, plotis);
	Plokst(plotis);
	//Y-
	glColor3f(0.0, 1.0, 0.0);
	glTranslatef(0.0, 0.0, -plotis / 2.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glTranslatef(0.0, 0.0, plotis / 2.0);
	Plokst(plotis);
	//Y+
	glRotatef(180.0, 1.0, 0.0, 0.0);
	glTranslatef(0.0, 0.0, plotis);
	Plokst(plotis);
	//Z-
	glColor3f(0.0, 0.0, 1.0);
	glTranslatef(0.0, 0.0, -plotis / 2.0);
	glRotatef(-90.0, 0.0, 1.0, 0.0);
	glTranslatef(0.0, 0.0, plotis / 2.0);
	Plokst(plotis);
	//Z+
	glRotatef(180.0, 0.0, 1.0, 0.0);
	glTranslatef(0.0, 0.0, plotis);
	Plokst(plotis);
	//Atstatoma pradine transformacija
	glTranslatef(0.0, 0.0, -plotis / 2.0);
	glRotatef(90.0, 0.0, 0.0, 1.0);
	glEndList();
}


inline void KGeom::KubasWire(GLfloat x = 1.0)
{
	glScalef(x, x, x);
	glCallList(dl + KUBAS_WIRE);
	glScalef(1.0 / x, 1.0 / x, 1.0 / x);
}


inline void KGeom::KubasWire(GLfloat x, GLfloat y, GLfloat z)
{
	glScalef(x, y, z);
	glCallList(dl + KUBAS_WIRE);
	glScalef(1.0 / x, 1.0 / y, 1.0 / z);
}


void KGeom::KubasWireDL()
{
	GLfloat plotis = 0.5;
	glNewList(dl + KUBAS_WIRE, GL_COMPILE);
	//Pagrindinis karkasas
	glBegin(GL_LINE_LOOP);
		glVertex3f(-plotis, -plotis, -plotis);
		glVertex3f(plotis, -plotis, -plotis);
		glVertex3f(plotis, plotis, -plotis);
		glVertex3f(-plotis, plotis, -plotis);
		glVertex3f(-plotis, plotis, plotis);
		glVertex3f(plotis, plotis, plotis);
		glVertex3f(plotis, -plotis, plotis);
		glVertex3f(-plotis, -plotis, plotis);
	glEnd();
	//Trukstamos briaunos
	glBegin(GL_LINES);
		glVertex3f(-plotis, -plotis, -plotis);
		glVertex3f(-plotis, plotis, -plotis);
		glVertex3f(-plotis, -plotis, plotis);
		glVertex3f(-plotis, plotis, plotis);
		glVertex3f(plotis, -plotis, -plotis);
		glVertex3f(plotis, -plotis, plotis);
		glVertex3f(plotis, plotis, -plotis);
		glVertex3f(plotis, plotis, plotis);
	glEnd();
	glEndList();
}


inline void KGeom::Ziedas()
{
	glCallList(dl + ZIEDAS);
}


void KGeom::ZiedasDL(int kok, int kok2, float dyd, float dyd2)
{
	//Issaugoti ziedo tasku koordinates
	float *duom = new float[kok2 * 2 + 2];
	for(i = 0; i <= kok2; i++){
		f = M_PI * 2.0 / kok2 * i;
		duom[i * 2] = sin(f) * dyd2;
		duom[i * 2 + 1] = cos(f) * dyd2;
	}
	
	//Sukurti solid display lista
	glNewList(dl + ZIEDAS, GL_COMPILE);
	for(i = 0; i < kok; i++){
		f = M_PI * 2.0 / kok * i;
		f2 = M_PI * 2.0 / kok * (i + 1);
		glBegin(GL_QUAD_STRIP);
		for(j = 0; j <= kok2; j++){
			glNormal3f(sin(f) * duom[j * 2], cos(f) * duom[j * 2], duom[j * 2 + 1]);
			glTexCoord2f(3.0 * i / kok, float(j) / kok2);
			glVertex3f(sin(f) * duom[j * 2] + sin(f) * dyd, cos(f) * duom[j * 2] + cos(f) * dyd, duom[j * 2 + 1]);
			
			glNormal3f(sin(f2) * duom[j * 2], cos(f2) * duom[j * 2], duom[j * 2 + 1]);
			glTexCoord2f(3.0 * (i + 1) / kok, float(j) / kok2);
			glVertex3f(sin(f2) * duom[j * 2] + sin(f2) * dyd, cos(f2) * duom[j * 2] + cos(f2) * dyd, duom[j * 2 + 1]);
		}
		glEnd();
	}
	glEndList();
	
	delete[] duom;
}


inline void KGeom::ZiedasWire()
{
	glCallList(dl + ZIEDAS_WIRE);
}


void KGeom::ZiedasWireDL(int kok, int kok2, float dyd, float dyd2)
{
	//Issaugoti ziedo tasku koordinates
	float *duom = new float[kok2 * 2 + 2];
	for(i = 0; i <= kok2; i++){
		f = M_PI * 2.0 / kok2 * i;
		duom[i * 2] = sin(f) * dyd2;
		duom[i * 2 + 1] = cos(f) * dyd2;
	}
	
	//Sukurti wire display lista
	glNewList(dl + ZIEDAS_WIRE, GL_COMPILE);
	//Piesiami mazieji ziedai
	for(i = 0; i < kok; i++){
		f = M_PI * 2.0 / kok * i;
		glBegin(GL_LINE_LOOP);
		for(j = 0; j < kok2; j++){
			glVertex3f(sin(f) * duom[j * 2] + sin(f) * dyd, cos(f) * duom[j * 2] + cos(f) * dyd, duom[j * 2 + 1]);
		}
		glEnd();
	}
	//Piesiami didieji ziedai
	for(i = 0; i < kok2; i++){
		glBegin(GL_LINE_LOOP);
		for(j = 0; j < kok; j++){
			f = M_PI * 2.0 / kok * j;
			glVertex3f(sin(f) * duom[i * 2] + sin(f) * dyd, cos(f) * duom[i * 2] + cos(f) * dyd, duom[i * 2 + 1]);
		}
		glEnd();
	}
	glEndList();
	
	delete[] duom;
}
