/***********************************************************
	Geometriniai objektai

	 2008 A-E Software 
	Arvydas Burdulis
	http://ae.gamedev.lt  aab@auto.lt


	Piesiami geometriniai objektai, tokie kaip plokstuma,
	apskritimas, ziedas. Yra wire/solid versijos.
	Generuojami display list'ai.

	Pradeta:
	    2007-12-02
	Paskutini karta redaguota:
	    2008-09-29
************************************************************/


#ifndef GEOM_OBJ_HPP
#define GEOM_OBJ_HPP


class KGeom
{
	public:
	
	static const int PLOKST0 =		0;
	static const int PLOKST =		1;
	static const int PLOKST_WIRE =	2;
	static const int KUBAS =		3;
	static const int KUBAS_SP = 	4;
	static const int KUBAS_WIRE =	5;
	static const int ZIEDAS =		6;
	static const int ZIEDAS_WIRE =	7;
	static const int KIEK = 		8;
	GLuint dl;
	
	KGeom();
	~KGeom();
	inline void GenDL();		//Generuojami display listai
	void Init();				//Sukuriami display listai
	void Naikinti();			//Naikinami duomenys
	
	//2D
	inline void Plokst(GLfloat plotis);
	inline void Plokst(GLfloat plotis, GLfloat aukstis);
	void PlokstDL();
	inline void PlokstWire(GLfloat plotis);
	inline void PlokstWire(GLfloat plotis, GLfloat aukstis);
	void PlokstWireDL();
	void Apskritimas(GLfloat dydis, int kokybe);
	void Skritulys(GLfloat dydis, int kokybe);
	void Ziedas2D(GLfloat dydis1, GLfloat dydis2, int kokybe);
	
	//3D
	void Koord(GLfloat dydis, int tarpu);
	inline void Kubas(GLfloat x);
	inline void Kubas(GLfloat x, GLfloat y, GLfloat z);
	void KubasDL();
	inline void KubasSp(GLfloat x);
	inline void KubasSp(GLfloat x, GLfloat y, GLfloat z);
	void KubasSpDL();
	inline void KubasWire(GLfloat x);
	inline void KubasWire(GLfloat x, GLfloat y, GLfloat z);
	void KubasWireDL();
	inline void Ziedas();
	void ZiedasDL(int kok = 24, int kok2 = 8, float dyd = 2.0, float dyd2 = 0.5);
	inline void ZiedasWire();
	void ZiedasWireDL(int kok = 24, int kok2 = 8, float dyd = 2.0, float dyd2 = 0.5);
} geom;


#include "geom_obj.cpp"
#endif
