KKamera::KKamera(): k(0.0, -0.001, 0.66),
  gr(0.0), gr2(0.0), grInert(0.0), atejo(true)
{
}


KKamera::~KKamera()
{
}


void KKamera::Atnaujinti()
{
	float dif;
	//Skaiciuoti taikinio pozicija
	/*t.x = cos(kh) * sin(kh) + k.x;
	t.y = sin(kh) * sin(kv) + k.y;
	t.z = -cos(kv) + k.z;*/
	
	//Atnaujinti greiti
	if(gr < gr2){
		gr += grInert * laik;
		if(gr > gr2)
			gr = gr2;
	}
	else if(gr > gr2){
		gr -= grInert * laik;
		if(gr < gr2)
			gr = gr2;
	}
	
	//Atnaujinti kameros pozicija (skristi link naujos pozicijos)
	k += (k2 - k).IlgisMaks(gr * laik);
	
	//Atnaujinti taikinio pozicija (skristi link naujos taikinio pozicijos)
	t += (t2 - t).IlgisMaks(gr * laik);
	
	if((k2 - k).Ilgis() < 0.01 && (t2 - t).Ilgis() < 0.01)
		atejo = true;
}


void KKamera::NustKam(float _x, float _y, float _z)
{
	k.x = _x;
	k.y = _y;
	k.z = _z;
}


void KKamera::NustTaik(float _x, float _y, float _z)
{
	t.x = _x;
	t.y = _y;
	t.z = _z;
}


void KKamera::Eiti(KTaskas *_k = NULL, KTaskas *_t = NULL)
{
	if(_k != NULL)
		k2 = _k;
	if(_t != NULL)
		t2 = _t;
	atejo = false;
}


void KKamera::EitiKam(float kx, float ky, float kz)
{
	k2.x = kx;
	k2.y = ky;
	k2.z = kz;
	atejo = false;
}


void KKamera::EitiTaik(float tx, float ty, float tz)
{
	t2.x = tx;
	t2.y = ty;
	t2.z = tz;
	atejo = false;
}
