KZiedas2::KZiedas2(): kh(0.0), kv(0.0), pas_h(0.0), pas_v(0.0), dydis(7.0), dydisMin(1.5),
  plX(0.0), plY(0.0), plNX(0.0), plNY(0.0), baigti(false), baigta(false)
{
}


KZiedas2::~KZiedas2()
{
}


void KZiedas2::Sukurti()
{
	//Sukurti tekstura
	memset(tekDuom, 0, tekDydis);
	for(i = 0; i < tekDydisi; i++){
		tekDuom[i * 4 + 0] = ((i % 255) & (i / 255) % 255) % 56 + 200;
		tekDuom[i * 4 + 1] = tekDuom[i * 4 + 0];
		tekDuom[i * 4 + 2] = tekDuom[i * 4 + 0];
		tekDuom[i * 4 + 3] = 255;
	}
	tek = tekstura.Sukurti();
	
	//Sukurti CubeMap tekstura
	unsigned char sk;
	memset(tekDuom, 255, tekDydis);
	for(i = 0; i < tekX; i++){
		for(j = 0; j < tekX; j++){
			sk = 0;
			f = sqrt((i - tekX / 2.0) * (i - tekX / 2.0) + (j - tekX / 2.0) * (j - tekX / 2.0));
			if(f < tekX / 2.0)
				sk = (unsigned char)(255.0 - f * 2.0);
			tekDuom[i * tekX * 4 + j * 4 + 0] = sk;
			tekDuom[i * tekX * 4 + j * 4 + 1] = sk;
			tekDuom[i * tekX * 4 + j * 4 + 2] = sk;
		}
	}
	tekCube = tekstura.SukurtiCubeMap();
	
	//Issaugoti ziedo tasku koordinates
	/*float *duom = new float[kok2 * 2 + 2];
	for(i = 0; i <= kok2; i++){
		f = M_PI * 2.0 / kok2 * i;
		duom[i * 2] = sin(f) * dyd2;
		duom[i * 2 + 1] = cos(f) * dyd2;
	}
	
	//Sukurti solid display lista
	dls = glGenLists(1);
	glNewList(dls, GL_COMPILE);
	for(i = 0; i < kok; i++){
		f = M_PI * 2.0 / kok * i;
		f2 = M_PI * 2.0 / kok * (i + 1);
		glBegin(GL_QUAD_STRIP);
		for(j = 0; j <= kok2; j++){
			glNormal3f(sin(f) * duom[j * 2], cos(f) * duom[j * 2], duom[j * 2 + 1]);
			glTexCoord2f(3.0 * i / kok, float(j) / kok2);
			glVertex3f(sin(f) * duom[j * 2] + sin(f) * dyd, cos(f) * duom[j * 2] + cos(f) * dyd, duom[j * 2 + 1]);
			
			glNormal3f(sin(f2) * duom[j * 2], cos(f2) * duom[j * 2], duom[j * 2 + 1]);
			glTexCoord2f(3.0 * (i + 1) / kok, float(j) / kok2);
			glVertex3f(sin(f2) * duom[j * 2] + sin(f2) * dyd, cos(f2) * duom[j * 2] + cos(f2) * dyd, duom[j * 2 + 1]);
		}
		glEnd();
	}
	glEndList();
	
	//Sukurti wire display lista
	dlw = glGenLists(1);
	glNewList(dlw, GL_COMPILE);
	//Piesiami mazieji ziedai
	for(i = 0; i < kok; i++){
		f = M_PI * 2.0 / kok * i;
		glBegin(GL_LINE_LOOP);
		for(j = 0; j < kok2; j++){
			glVertex3f(sin(f) * duom[j * 2] + sin(f) * dyd, cos(f) * duom[j * 2] + cos(f) * dyd, duom[j * 2 + 1]);
		}
		glEnd();
	}
	//Piesiami didieji ziedai
	for(i = 0; i < kok2; i++){
		glBegin(GL_LINE_LOOP);
		for(j = 0; j < kok; j++){
			f = M_PI * 2.0 / kok * j;
			glVertex3f(sin(f) * duom[i * 2] + sin(f) * dyd, cos(f) * duom[i * 2] + cos(f) * dyd, duom[i * 2 + 1]);
		}
		glEnd();
	}
	glEndList();
	
	delete[] duom;*/
}


void KZiedas2::Atnaujinti()
{
	if(dydis > dydisMin && !baigti)
		dydis -= laik * 0.5;
	else{
		if(kv < 90.0){
			kv += laik * 11.1;
		}
		else{
			//Pasisukimas
			kv += laik * 11.1;
			kh += laik * 4.1;
			//Plokstumos pozicija
			f = laik / 5;
			if(plX - plNX < laik && plNX - plX < f)
				plNX = (float)(rand() % 1024) / 1576.0 * dydis;
			if(plY - plNY < laik && plNY - plY < f)
				plNY = (float)(rand() % 1024) / 1576.0 * dydis;
			plX += (plNX - plX > 0.0) ? f : -f;
			plY += (plNY - plY > 0.0) ? f : -f;
			//Plokstumos pasisukimas
			pas_h += laik * 15.1;
			pas_v += laik * 11.3;
		}
	}
	if(dydis < dydisMin)
		dydis = dydisMin;
	if(baigti){
		if(kv > 360.0){
			baigta = true;
			dydis += laik * 0.5;
		}
		if(kv > 360.0)
			kv = 360.0;
	}
}


void KZiedas2::Baigti()
{
	baigti = true;
	while(kv > 360.0)
		kv -= 360.0;
}


void KZiedas2::PiestiStencil()
{
	glPushMatrix();
	glRotatef(kh, 0.0, 0.0, 1.0);
	glRotatef(kv, 1.0, 0.0, 0.0);
	geom.Skritulys(dydis * 2.0, 8);
	glPopMatrix();
}


void KZiedas2::Piesti()
{
	plokst.Normale(pas_h, pas_v);
	f = (kamera.t - kamera.k) ^ plokst;	//Kampo tarp kameros krypties ir plokstumos normales kosinusas
	glBindTexture(GL_TEXTURE_2D, tek);
	glPushMatrix();
	glScalef(dydis, dydis, dydis);
	
	if(kv < 90.0){
		glRotatef(kv, 1.0, 0.0, 0.0);
		PiestiZieda();
	}
	else{
		//Irasyti Z-buferio reiksmes
		glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
		glPushMatrix();
		glTranslatef(plX, plY, 0.0);
		glRotatef(pas_h, 0.0, 0.0, 1.0);
		glRotatef(pas_v, 1.0, 0.0, 0.0);
		geom.Plokst(100.0);
		glPopMatrix();
		glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
		
		//Piesti pirma
		glPushAttrib(GL_DEPTH_FUNC);
		glDepthFunc(GL_GREATER);
		glPushMatrix();
		glRotatef(kh, 0.0, 0.0, 1.0);
		glRotatef(kv, 1.0, 0.0, 0.0);
		//if(f > 0.0)
		//	geom.Ziedas();
		//else
			geom.ZiedasWire();
		glPopMatrix();
		glPopAttrib();
		
		//Irasyti Z-buferio reiksmes
		glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
		glPushMatrix();
		glTranslatef(plX, plY, 0.0);
		glRotatef(pas_h, 0.0, 0.0, 1.0);
		glRotatef(pas_v, 1.0, 0.0, 0.0);
		geom.Plokst(100.0);
		glPopMatrix();
		glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
		
		//Piesti antra
		glPushMatrix();
		glRotatef(kh, 0.0, 0.0, 1.0);
		glRotatef(kv, 1.0, 0.0, 0.0);
		//if(f > 0.0)
		//	geom.ZiedasWire();
		//else
		//	geom.Ziedas();
		PiestiZieda();
		glPopMatrix();
		
		#ifdef DEBUG
		glBegin(GL_LINES);
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(plokst.x, plokst.y, plokst.z);
		glEnd();
		#endif
	}
	
	glPopMatrix();
}


void KZiedas2::PiestiZieda()
{
	if(OglExt::ok_Multitexture)
		OglExt::glActiveTexture(GL_TEXTURE0);
	glEnable(GL_TEXTURE_2D);
	if(OglExt::ok_Multitexture){
		glBindTexture(GL_TEXTURE_2D, tek);
		OglExt::glActiveTexture(GL_TEXTURE1);
	}
	
	//Pasukti CubeMap tekstura
	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();
	glRotatef(pas_h, 1.0, 0.0, 0.0);
	glRotatef(pas_v, 0.0, 1.0, 0.0);
	glMatrixMode(GL_MODELVIEW);
	if(OglExt::ok_Cubemap){
		glEnable(GL_TEXTURE_CUBE_MAP);
		glBindTexture(GL_TEXTURE_CUBE_MAP, tekCube);
		glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
		glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
		glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
		glEnable(GL_TEXTURE_GEN_S);
		glEnable(GL_TEXTURE_GEN_T);
		glEnable(GL_TEXTURE_GEN_R);
	}
	geom.Ziedas();
	if(OglExt::ok_Cubemap){
		glDisable(GL_TEXTURE_GEN_R);
		glDisable(GL_TEXTURE_GEN_T);
		glDisable(GL_TEXTURE_GEN_S);
		glDisable(GL_TEXTURE_CUBE_MAP);
		OglExt::glActiveTexture(GL_TEXTURE0);
	}
}
