const void KTekstura::Remelis(int n = 1)
{
	for(i = 0; i < tekX; i++){
		for(j = 0; j < n; j++){
			*(tekDuomi + tekX * j + i) = 0;	//Apacia
			*(tekDuomi + tekDydisi - tekX * (j + 1) + i) = 0;	//Virsus
			*(tekDuomi + tekX * i + j) = 0;	//Kaire
			*(tekDuomi + tekX * i + tekX - 1 - j) = 0;	//Desine
		}
	}
}


const GLuint KTekstura::Sukurti(unsigned char *duom = tekDuom, GLuint x = tekX, GLuint y = tekX,
  GLuint glTipas = GL_RGBA, GLuint glTipas2 = GL_RGBA8)
{
	#ifdef DEBUG
	GLenum klaida;
	#endif
	GLuint tek;
	glGenTextures(1, &tek);
	glBindTexture(GL_TEXTURE_2D, tek);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    if(OglExt::ok_Anisotropic)
    	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, anisoMax);
    else
    	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);

    glTexImage2D(GL_TEXTURE_2D, 0, glTipas, x, y, 0, glTipas2, GL_UNSIGNED_BYTE, duom);
    #ifdef DEBUG
    klaida = gluBuild2DMipmaps(GL_TEXTURE_2D, glTipas2, x, y, glTipas, GL_UNSIGNED_BYTE, duom);
    if(klaida != 0){
		const GLubyte *kl = gluErrorString(klaida);
		char str[128];
		strcpy(str, (const char*)kl);
		Klaida(str);
		return 0;
	}
    #else
    gluBuild2DMipmaps(GL_TEXTURE_2D, glTipas2, x, y, glTipas, GL_UNSIGNED_BYTE, duom);
    #endif

	glBindTexture(GL_TEXTURE_2D, 0);
	#ifdef DEBUG
	if(!glIsTexture(tek)){
		Klaida("KL");
		return 0;
	}
	#endif
	return tek;
}


const GLuint KTekstura::SukurtiCubeMap()
{
	#ifdef DEBUG
	GLenum klaida;
	#endif
	GLuint tek;
	glGenTextures(1, &tek);
	glEnable(GL_TEXTURE_CUBE_MAP);
	glBindTexture(GL_TEXTURE_CUBE_MAP, tek);
    glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    for(int i = 0; i < 6; i++)
    	glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_X + i, 0, GL_RGBA, tekX, tekX, 0, GL_RGBA, GL_UNSIGNED_BYTE, tekDuom);
	//gluBuild2DMipmaps(GL_TEXTURE_CUBE_MAP, tga.glTipas, tga.x, tga.y, tga.glTipas2, GL_UNSIGNED_BYTE, tga.data);

	glBindTexture(GL_TEXTURE_CUBE_MAP, 0);
	glDisable(GL_TEXTURE_CUBE_MAP);
	#ifdef DEBUG
	if(!glIsTexture(tek)){
		Klaida("KL");
		return 0;
	}
	#endif
	
	return tek;
}
